//----------------------------------------------------------------------//
// NyanFi																//
//  摜r[Xbh												//
//----------------------------------------------------------------------//
#ifndef ImgViewThreadH
#define ImgViewThreadH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>

//---------------------------------------------------------------------------
class TImgViewThread : public TThread
{
private:
	UnicodeString Img_f_name;
	__int64		  Img_f_size;
	TDateTime	  Img_f_time;
	UnicodeString Img_rot_str;	//^t@C̉]E]
	bool ChgPrvCur;				//vr[̃}EX|C^ύX

	UnicodeString MsgStr;
	bool MsgIsErr;

	TStringList *RequestList;	//L[

	TMultiReadExclusiveWriteSynchronizer *TaskRWLock;
	bool FTaskBusy;
	bool __fastcall GetTaskBusy();
	void __fastcall SetTaskBusy(bool Value);
	__property bool TaskBusy = {read = GetTaskBusy,  write = SetTaskBusy};				//

	void __fastcall ClearImage();
	void __fastcall DrawImage();
	void __fastcall DrawViewBuff();
	void __fastcall DrawMessage();
	void __fastcall Execute();

public:
	UnicodeString FileName;		//v摜t@C
	UnicodeString FileName2;

	bool ReqRedraw;			//ĕ`v
	bool ReqReload;			//[hv
	bool ReqClear;			//ʃNAv
	bool ReqVideo;			//(TlC\v)
	bool ReqWait;			//MinShowTime ɂ҂v
	bool UseViewBuff;		//CŐݒ肳ꂽobt@egp
	int  Rotation;			//]/]v (1,3,4,5)
	int  ExifOri;			//Exif ̕
	int  ZoomRatio;			//Y[{(%)
	double ZoomRatioF;

	bool Fitted;			//tBbg\
	bool GrayScaled;		//O[XP[\
	bool ShowGrid;			//Obh\

	bool ImgIsWmf;

	Graphics::TBitmap *ImgBuff;		//摜obt@(TCY)
	Graphics::TBitmap *ViewBuff;	//\obt@
	Graphics::TBitmap *ChgBuff;
	TMetafile *MetaBuff;			//^t@Cpobt@

	__fastcall TImgViewThread(bool CreateSuspended);
	bool __fastcall IsReady();
	bool __fastcall IsWaiting();
	void __fastcall AddRequest(const _TCHAR *cmd, UnicodeString prm1 = EmptyStr, UnicodeString prm2 = EmptyStr);
	void __fastcall AddRequest(const _TCHAR *cmd, int prm);
};
//---------------------------------------------------------------------------
#endif
